<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use Teknisa\PED\Modules\Pedidos\Services\ped00301PosicaoService;
use \Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\Libs\Util\DateUtil;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DTO;

class ped00301PosicaoController extends TeknisaCrud {

    protected $parameterBag;
    protected $environment;
    protected $entityManager;
    protected $posicaoService;

    public function __construct($crudService, ParameterBag $parameterBag, $environment, $entityManager, $posicaoService) {
        parent::__construct($crudService, $parameterBag);
        $this->parameterBag = $parameterBag;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->posicaoService = $posicaoService;
    }

    public function returnPosicaoFinanceira($request, $response) {
        $data = $request->getDataSet();
        $rows = $data->getRows();
        $search = $this->posicaoService->returnPosicaoFinanceira($rows);
        $dataset = new DataSet('posicaoFinanceira', $search);
        $response->setDataSets(array($dataset));
    }
    
    public function returnContasAbertas($request, $response) {
        $data = $request->getDataSet();
        $rows = $data->getRows();
        $search = $this->posicaoService->returnContasAbertas($rows);
        $dataset = new DataSet('contasAbertas', $search);
        $response->setDataSets(array($dataset));
    }
    
    public function returnTipoRecAbertas($request, $response) {
        $data = $request->getDataSet();
        $rows = $data->getRows();
        $search = $this->posicaoService->returnTipoRecAbertas($rows);
        $dataset = new DataSet('tipoRecAbertas', $search);
        $response->setDataSets(array($dataset));
    }
    
    public function returnContasFechadas($request, $response) {
        $data = $request->getDataSet();
        $rows = $data->getRows();
        $search = $this->posicaoService->returnContasFechadas($rows);
        $dataset = new DataSet('contasFechadas', $search);
        $response->setDataSets(array($dataset));
    }
    
    public function returnTipoRecFechadas($request, $response) {
        $data = $request->getDataSet();
        $rows = $data->getRows();
        $search = $this->posicaoService->returnTipoRecAbertas($rows);
        $dataset = new DataSet('tipoRecAbertas', $search);
        $response->setDataSets(array($dataset));
    }
    
    public function returnEndereco($request, $response) {
        $data = $request->getDataSet();
        $rows = $data->getRows();
        $search = $this->posicaoService->returnEndereco($rows);
        $dataset = new DataSet('endereco', $search);
        $response->setDataSets(array($dataset));
    }
    
    public function returnHistorico($request, $response) {
        $data = $request->getDataSet();
        $rows = $data->getRows();
        $search = $this->posicaoService->returnHistorico($rows);
        $dataset = new DataSet('historico', $search);
        $response->setDataSets(array($dataset));
    }
    
    public function returnHistContas($request, $response) {
        $data = $request->getDataSet();
        $rows = $data->getRows();
        $search = $this->posicaoService->returnHistContas($rows);
        $dataset = new DataSet('historicoContas', $search);
        $response->setDataSets(array($dataset));
    }
}